
Ray lidar;
ArrayList<Reflector> reflectors;
ClusterEngine brain;
//ArrayList<Vertex> rays;

int N = 1000;
int noise = 1;

void setup(){
  size(1200,800);
  frameRate(60);
  
  randomSeed(0);
  
  brain = new ClusterEngine(10);
  reflectors = new ArrayList<Reflector>();
  //rays = new ArrayList<Vertex>();
  
  lidar = new Ray(width/2, height/2,500);
}

void draw(){
  //rays.clear();
  background(52);

  lidar.update(500);
  
  if(keyPressed)brain.compute(50);
  for(int i = 0; i < reflectors.size(); i++){
     //reflectors.get(i).pos = new PVector(mouseX, mouseY);//display();
  }
  //for(int i = 0; i < rays.size(); i++){
     //rays.get(i).display();
  //}
  brain.draw();
  
}



void mousePressed(){
  println("[Event] : Mouse pressed !");
  reflectors.add(new Reflector(mouseX, mouseY, 50));
  

  print("[Info] : "); 
  print(reflectors.size()); 
  println(" in scene");
  
  background(52);
  
}


void sort(){
    ArrayList<Reflector> unsortedReflectors = reflectors ;
  ArrayList<Reflector> sortedReflectors = new ArrayList<Reflector>() ;
  
  while(unsortedReflectors.size() > 0){
    float min = 2000;
    Reflector buffer = new Reflector(0,0,0);
   
    for(int i = 0; i < unsortedReflectors.size(); i++){
      float dist = PVector.dist(unsortedReflectors.get(i).pos, lidar.origin);
      if(dist < min){
        min = dist;
        buffer = unsortedReflectors.get(i);
      }
    }
    sortedReflectors.add(buffer);
    unsortedReflectors.remove(buffer);
  }
  
  //reflectors.clear();
  reflectors = sortedReflectors;
  
}
